import json

import asyncio
import logging
from dataclasses import dataclass, field
from enum import Enum
from json import JSONDecodeError
from typing import Any, AsyncIterable, Optional, Sequence
from urllib.parse import urlparse

import fastapi
import fastapi.params
import uvicorn as uvicorn
from fastapi import Depends, FastAPI, HTTPException, Request, Response
from fastapi.responses import StreamingResponse
from fastapi.security import APIKeyHeader
from opentelemetry.instrumentation.fastapi import FastAPIInstrumentor
from prometheus_client import Histogram
from pydantic import BaseModel, Field, create_model
from starlette import status

from ryax.common.application.message_bus import tracer
from ryax.runner.application.user_auth_service import UserAuthService
from ryax.runner.application.workflow_result_service import WorkflowResultService
from ryax.runner.domain.action_definition.action_definition_entities import (
    UnsupportedIOType,
)
from ryax.runner.domain.action_definition.action_definition_values import (
    DynamicOutputOrigin,
    ActionIOType,
)
from ryax.runner.domain.execution_connection.execution_connection_commands import (
    InitializeExecutionResultCommand,
)
from ryax.runner.domain.execution_result.execution_result_events import (
    ExecutionResultFinishedEvent,
)
from ryax.runner.domain.execution_result.execution_result_values import (
    ExecutionResultState,
)
from ryax.common.domain.internal_messaging.message_bus import IMessageBus
from ryax.runner.domain.stored_file.stored_file import StoredFile
from ryax.runner.domain.stored_file.stored_file_service import IStoredFileView
from ryax.runner.domain.user_auth.api_key.user_api_key_exceptions import (
    UserApiKeyNotPresentInHeaderException,
)
from ryax.runner.domain.user_auth.user_auth_exceptions import (
    UserAuthUnauthorizedException,
)
from ryax.runner.domain.workflow_action.workflow_action import WorkflowAction
from ryax.runner.domain.workflow_result.workflow_result import (
    WorkflowResultsUnavailableError,
    WorkflowResultsUserDefinedError,
)
from ryax.runner.domain.workflow_run.workflow_run_events import (
    WorkflowRunIsCompletedEvent,
)

logger = logging.getLogger(__name__)

requests_processing_time = Histogram(
    "ryax_user_api_requests_duration_seconds",
    "Histogram of requests processing time by path (in seconds)",
    [
        "ryax_user_api_http_path",
        "ryax_user_api_http_method",
        "ryax_project",
    ],
)


class APIGatewayUnsupportedTypeError(Exception):
    ...


class APIGatewayUnsupportedMethodError(Exception):
    ...


class APIGatewayUnsupportedSuccessStatusCodeError(Exception):
    ...


class APIGatewayMalformedEndpoint(Exception):
    ...


class APIEndpointTemplateError(Exception):
    ...


class HTTPSuccessCode(Enum):
    SUCCESS_200 = "200"
    CREATED_201 = "201"


class HTTPMethod(Enum):
    GET = "GET"
    POST = "POST"
    PUT = "PUT"
    PATCH = "PATCH"
    DELETE = "DELETE"
    # Do not implement these in our API gateway because they are not relevant in this case
    # HEAD: str = "HEAD"
    # OPTIONS: str = "OPTIONS"
    # TRACE: str = "TRACE"
    # CONNECT: str = "CONNECT"


class HTTPPath(str):
    # TODO Add a prefix validation
    pass


@dataclass
class HTTPEndpoint:
    method: str
    code: HTTPSuccessCode
    path: str
    target_workflow_definition_id: str
    prefix_path: str
    async_reply_timeout: float
    project_id: str


class ErrorsModel(BaseModel):
    errors: list[str]


class AsyncResponseSchema(BaseModel):
    result_link: str = Field(
        description="A link that will give you the result once ready",
        examples=["/result/wfrid-12345aezz"],
    )
    workflow_run_id: str = Field(
        title="Workflow run id",
        description="ID of the created workflow run. If you request very fast, the system might respond not found, wait a bit.",
        examples=["wfrid-123-abcd"],
    )


def url_join(url_parts: list[Optional[str]]) -> str:
    try:
        return "/" + "/".join(s.strip("/") for s in url_parts if s)
    except AttributeError:
        raise APIGatewayMalformedEndpoint()


@dataclass
class ApiServer:
    prefix_path: str
    app: FastAPI


@dataclass
class FastAPIApiGateway:
    base_url_prefix: str
    result_url_prefix: str
    message_bus: IMessageBus
    workflow_result_service: WorkflowResultService
    user_auth_service: UserAuthService
    stored_files: IStoredFileView
    _endpoints: list[HTTPEndpoint] = field(default_factory=list)
    _api_servers: dict[str, ApiServer] = field(default_factory=dict)
    root_app: FastAPI = field(default_factory=FastAPI)
    server: Optional[uvicorn.Server] = None
    server_task: Optional[asyncio.Task] = None
    server_port: int = 10080

    def _register_prefix(
        self,
        prefix_path: str,
        api_title: str = "My Ryax Project API",
        api_description: str = "This API is generated by Ryax 🚀",
    ) -> None:
        if prefix_path not in self._api_servers:
            app = FastAPI(
                title=api_title,
                description=api_description,
            )

            self._api_servers[prefix_path] = ApiServer(prefix_path, app)
            try:
                self.root_app.mount(prefix_path, app)
            except AssertionError as err:
                raise APIGatewayMalformedEndpoint(err)
            logger.debug(f"New API registered on path: {prefix_path}")

    async def start(self) -> None:
        # Setup logging
        logging.basicConfig(
            level=logging.INFO,
            format="%(asctime)s.%(msecs)03d %(levelname)-7s %(name)-22s %(message)s",
            datefmt="%Y-%m-%d,%H:%M:%S",
        )

        # FIXME: Remove sensitive headers with for example:
        #  export OTEL_INSTRUMENTATION_HTTP_CAPTURE_HEADERS_SANITIZE_FIELDS=".*session.*,set-cookie"
        FastAPIInstrumentor.instrument_app(self.root_app)

        config = uvicorn.Config(
            self.root_app,
            host="0.0.0.0",
            port=self.server_port,
            log_level="info",
            access_log=True,
            loop="asyncio",
            root_path=self.base_url_prefix,
        )
        self.server = uvicorn.Server(config)
        self.server.install_signal_handlers = lambda: None  # type: ignore
        self.server_task = asyncio.create_task(self.server.serve())

    async def stop(self, wait_completion: bool = True, timeout: int = 1) -> None:
        server = self.server
        assert server is not None
        server.should_exit = True
        server.force_exit = True
        await server.shutdown()
        if wait_completion:
            # TODO find a better way to do this. This is still an open issue:
            # https://github.com/encode/uvicorn/discussions/1103
            if self.server_task:
                await asyncio.wait_for(self.server_task, timeout=timeout)

    @staticmethod
    def get_param_default_value(origin: DynamicOutputOrigin) -> fastapi.params.Param:
        if origin == DynamicOutputOrigin.PATH:
            return fastapi.Path()
        elif origin == DynamicOutputOrigin.QUERY:
            return fastapi.Query(default=None)
        elif origin == DynamicOutputOrigin.BODY:
            return fastapi.Body()
        elif origin == DynamicOutputOrigin.HEADER:
            return fastapi.Header()
        elif origin == DynamicOutputOrigin.COOKIE:
            return fastapi.Cookie()
        raise NotImplementedError(f"The parameter origin '{origin}' is not implemented")

    def register_handler(
        self,
        endpoint: HTTPEndpoint,
        trigger: WorkflowAction,
        method: HTTPMethod,
        code: HTTPSuccessCode,
    ) -> None:
        """
        Creates a handler with the following doc:
        - Description: from trigger inputs
        - Tag: from trigger inputs
        - request schema: Not defined. Load a JSON and put it in the body parameter defined in dyn outputs
        - response schema: depends on the results added to the workflow + 400 if parameters are missing
        - Query parameters: from dyn outputs
        - headers parameters: from dyn outputs
        - cookie parameters: from dyn outputs

        The handler must:
        - get all parameters from the request
        - manage errors for missing or ill formatted parameters
        - Initialize an execution connection
        - generate an execution result and send it

        Needed inputs:
        - trigger inputs and dyn outputs
        """
        # Generate parameters
        parameters_models = []
        body_parameters: dict = {}

        for parameter in trigger.dynamic_outputs:
            if parameter.origin is not None:
                if (
                    parameter.origin == DynamicOutputOrigin.PATH
                    and parameter.display_name not in endpoint.path
                ):
                    # TODO: do a better validation that actually parse the endpoint template
                    raise APIEndpointTemplateError(
                        f"The parameter '{parameter.display_name}' is missing in the endpoint path '{endpoint.path}'"
                    )
                default_value = self.get_param_default_value(parameter.origin)
                try:
                    if parameter.origin == DynamicOutputOrigin.BODY:
                        body_parameters[parameter.display_name] = (
                            parameter.to_python_type(),
                            default_value,
                        )
                    else:
                        param_model = {
                            parameter.display_name: (
                                parameter.to_python_type(),
                                default_value,
                            )
                        }
                        parameters_models.append(
                            create_model(  # type: ignore
                                parameter.display_name.capitalize(), **param_model
                            )
                        )
                except UnsupportedIOType:
                    raise APIGatewayUnsupportedTypeError(
                        f"The ryax type '{parameter.type}' for the parameter '{parameter.display_name}' is not supported as an API parameter"
                    )

        # create body parameters model
        body_parameters_model = None
        if len(body_parameters) > 0:
            body_parameters_model = create_model(  # type: ignore
                "RyaxBodyParameters", **body_parameters
            )

        async def handler(request: Request, response: Response) -> Any:
            # Get existing Request ID from header if exists or generate one and put it in the response

            metadata: dict[
                str,
                str
                | bool
                | int
                | float
                | Sequence[str]
                | Sequence[bool]
                | Sequence[int]
                | Sequence[float],
            ] = {
                "ryax_user_api_http_path": endpoint.path,
                "ryax_user_api_http_method": endpoint.method,
                "ryax_project": endpoint.project_id,
            }
            with requests_processing_time.labels(
                **metadata
            ).time(), tracer.start_as_current_span("Ryax User API call") as span:
                span.set_attributes(metadata)

                param_values = {}
                value_errors = []

                for param in trigger.dynamic_outputs:
                    param_name = param.display_name
                    if param.origin == DynamicOutputOrigin.PATH:
                        value = request.path_params.get(param_name)
                    elif param.origin == DynamicOutputOrigin.HEADER:
                        value = request.headers.get(param_name)
                    elif param.origin == DynamicOutputOrigin.QUERY:
                        value = request.query_params.get(param_name)
                    elif param.origin == DynamicOutputOrigin.COOKIE:
                        value = request.cookies.get(param_name)
                    elif param.origin == DynamicOutputOrigin.BODY:
                        try:
                            json_body = await request.json()
                            value = json_body[param.display_name]
                        except (JSONDecodeError, TypeError) as err:
                            response.status_code = 400
                            return ErrorsModel(
                                errors=[
                                    f"Invalid body. Only JSON format is supported. Error details: {err}"
                                ]
                            )
                        except KeyError as err:
                            response.status_code = 400
                            return ErrorsModel(
                                errors=[
                                    f"Invalid body. Parameters {param.name} not available on the body {json_body}. Error details: {err}"
                                ]
                            )

                    else:
                        raise ValueError(
                            f"Unsupported parameter location: {param.origin}"
                        )

                    if value is None and param.optional is False:
                        value_errors.append(
                            f"Missing value for parameter '{param.display_name}'. Cannot be found in request's {param.origin.value}"
                        )

                    # In theory all the types should be correct, we could add validation here
                    # The following line will fix the case that we receive a dict, but it ought to be a json string
                    param_values[param.name] = (
                        json.dumps(value)
                        if (
                            param.type in [ActionIOType.STRING, ActionIOType.LONGSTRING]
                            and isinstance(value, dict)
                        )
                        else value
                    )

                if value_errors:
                    response.status_code = 400
                    return ErrorsModel(errors=value_errors)

                assert trigger.connection_execution_id is not None
                (
                    execution_result_id,
                    workflow_run_id,
                ) = await self.message_bus.handle_command(
                    InitializeExecutionResultCommand(
                        execution_connection_id=trigger.connection_execution_id,
                        executor_id="ryax_api_gateway",
                        log_delimiter=None,
                    )
                )
                wait_completion = self.message_bus.wait_for_event(
                    WorkflowRunIsCompletedEvent,
                    {"workflow_run_id": workflow_run_id},
                )
                task = asyncio.create_task(
                    self.message_bus.handle_event(
                        ExecutionResultFinishedEvent(
                            id=execution_result_id,
                            outputs=param_values,
                            status=ExecutionResultState.SUCCESS,
                            output_files=[],
                        )
                    )
                )
                if endpoint.async_reply_timeout < 0:
                    timeout = None
                else:
                    timeout = endpoint.async_reply_timeout

                try:
                    await asyncio.gather(
                        task,
                        asyncio.wait_for(
                            wait_completion,
                            timeout=timeout,
                        ),
                    )
                except asyncio.exceptions.TimeoutError:
                    response.status_code = 202
                    host = urlparse(str(request.url)).hostname
                    if "x-forwarded-proto" in request.headers:
                        scheme = request.headers["x-forwarded-proto"]
                    else:
                        scheme = urlparse(str(request.url)).scheme
                    return AsyncResponseSchema(
                        workflow_run_id=workflow_run_id,
                        result_link=scheme
                        + ":/"
                        + url_join(
                            [
                                host,
                                self.result_url_prefix,
                                f"results/{workflow_run_id}",
                            ]
                        ),
                    )

                try:
                    workflow_results = await self.workflow_result_service.get(
                        workflow_run_id, endpoint.project_id
                    )
                except WorkflowResultsUnavailableError:
                    response.status_code = 500
                    return ErrorsModel(
                        errors=["Unexpected error while processing the query."]
                    )
                except WorkflowResultsUserDefinedError as err:
                    response.status_code = err.code
                    return err.message

                if isinstance(workflow_results, StoredFile):
                    stored_file = workflow_results

                    async def iter_file() -> AsyncIterable[bytes]:
                        for chunk in await self.stored_files.download_file(
                            stored_file.file_path
                        ):
                            yield chunk

                    return StreamingResponse(
                        iter_file(), headers=stored_file.get_headers()
                    )
                else:
                    return workflow_results

        def api_key_auth(
            api_key: str = fastapi.Security(
                APIKeyHeader(name="X-API-KEY", auto_error=False)
            )
        ) -> None:
            try:
                self.user_auth_service.authenticate(
                    endpoint.project_id, {"X-API-KEY": api_key}
                )
            except (
                UserAuthUnauthorizedException,
                UserApiKeyNotPresentInHeaderException,
            ):
                raise HTTPException(
                    status_code=status.HTTP_401_UNAUTHORIZED, detail="Forbidden"
                )

        app = self._get_api_server_app(endpoint)
        full_path = url_join(
            [self.base_url_prefix, endpoint.prefix_path, endpoint.path]
        )
        try:
            tags = str(trigger.get_input_static_value("tags")).split(",")
        except AttributeError:
            tags = None

        app.add_api_route(
            endpoint.path,
            handler,
            methods=[method.value],
            tags=tags,  # type: ignore
            summary=str(trigger.get_input_static_value("summary")),
            description=str(trigger.get_input_static_value("description")),
            status_code=int(code.value),
            responses={
                int(code.value): {"description": "Success"},
                202: {
                    "description": "Async worker created successfully",
                    "model": AsyncResponseSchema,
                },
                400: {"description": "Malformed inputs", "model": ErrorsModel},
            },
            dependencies=[Depends(model) for model in parameters_models]
            + [Depends(api_key_auth)],
            openapi_extra=(
                {
                    "requestBody": {
                        "content": {
                            "application/json": {
                                "schema": body_parameters_model.schema()
                            }
                        },
                        "required": True,
                    },
                }
                if body_parameters_model is not None
                else None
            ),
        )
        logger.debug(f"New endpoint registered on path: {full_path}")

    async def add_endpoint(
        self, workflow_trigger: WorkflowAction, endpoint: HTTPEndpoint
    ) -> None:
        self._register_prefix(endpoint.prefix_path)

        try:
            method = HTTPMethod(endpoint.method)
        except ValueError:
            raise APIGatewayUnsupportedMethodError(
                f"{endpoint.method} is not a supported HTTP method."
            )

        try:
            code = HTTPSuccessCode(endpoint.code)
        except ValueError:
            raise APIGatewayUnsupportedSuccessStatusCodeError(
                f"{endpoint.method} is not a supported HTTP success status code."
            )

        # Do a better validation
        if ("{" in endpoint.path and "}" not in endpoint.path) or (
            "}" in endpoint.path and "{" not in endpoint.path
        ):
            raise APIGatewayMalformedEndpoint(
                f"The endpoint {endpoint} template string is invalid"
            )

        self.register_handler(endpoint, workflow_trigger, method, code)
        self._endpoints.append(endpoint)
        self._invalidate_openapi_cache(endpoint.prefix_path)

    async def remove_endpoint(self, workflow_definition_id: str) -> None:
        """
        Remove endpoint dynamically

        Taken from: https://stackoverflow.com/a/74035526/2165830

        Notes:
        Removing route dynamically is not supported in aiohttp!
        https://github.com/aio-libs/aiohttp/issues/752
        In fastAPI it seems to be the same but someone says removing it from the routes works:
        https://github.com/tiangolo/fastapi/issues/552
        """
        for endpoint in self._endpoints:
            if endpoint.target_workflow_definition_id == workflow_definition_id:
                self._endpoints.remove(endpoint)
                app = self._get_api_server_app(endpoint)
                for index, route in enumerate(app.router.routes):
                    if route.path_format == endpoint.path:  # type: ignore
                        del app.router.routes[index]
                self._invalidate_openapi_cache(endpoint.prefix_path)
                break

    def _get_api_server_app(self, endpoint: HTTPEndpoint) -> FastAPI:
        return self._api_servers[endpoint.prefix_path].app

    def _invalidate_openapi_cache(self, prefix_path: str) -> None:
        logger.debug(f"Invalidating OpenAPI doc for path {prefix_path}")
        self._api_servers[prefix_path].app.openapi_schema = None
        self._api_servers[prefix_path].app.setup()
